// FIXME: indexing here sucks

#include "rtree.h"

int main(int argc, char *argv[])
{
  assert(argc >= 3);
  int n = atoi(argv[1]);
  int r = atoi(argv[2]);
  generate_all_rtrees(n-1, r); // n is 1-based but depth is 0-based
  for (int i = 0; i < n; i++)
    {
      cout << all_rtrees[i].size() << " rtrees of height " << i
	   << " (should be " << count_rtrees(i, r) << ")" << endl;
      bint dimsum = 0;
      
      for (unsigned j = 0; j < all_rtrees[i].size(); j++)
	{
	  all_rtrees[i][j].print(cout);
	  const bint& dim = all_rtrees[i][j].get_dim();
	  cout << " [dim=" << dim << "]" << endl;
	  dimsum += dim * dim;
	}
      bint real_dim = wr_order(i+1, r);
      cout << "Total dimension is " << dimsum << " (should be "
	   << real_dim << ")" << endl;
    }
  return 0;
}
